;|

lin-export.LSP

|;

(defun C:lin-export (/ ltname tblent flag tblist i outf desc alist acode value
									 rot shpno shxfl shpfl inf dat n shpnm flg txt sty)
	(setq ltname (getstring "\nName des zu exportierenden Linientyps: "))
	(if (setq tblent (tblobjname "ltype" ltname))
		(progn
			(setq flag (findfile "exp_lt.lin")
						tblist (entget tblent)
						i 1
						outf (open (if flag flag "exp_lt.lin")(if flag "a" "w"))
						desc "A,")
			(setvar "luprec" 8)
			(setvar "auprec" 8)
			(if (null flag)
				(progn
					(write-line "" outf)
					(write-line "Die untenstehenden Linientypen wurden aus der" outf)
					(write-line "Zeichnung mit dem lin-export.LSP Befehl extrahiert." outf)
					(write-line "\n" outf)))
			(write-line (strcat "*" (cdr (assoc 2 tblist)) "," (cdr (assoc 3 tblist))) outf)
			(while (< i (length tblist))
				(setq alist (nth i tblist)
							acode (car alist)
							value (cdr alist))
				(cond
					((= acode 49)
						(setq desc (strcat desc (trim (rtos value 2 8)) ",")))
					((= acode 74)
						(setq flag (if (= (logand value 4) 4) T nil)
									rot (if (= (logand value 1) 1) "a" "r")))
					((= acode 75)
						(setq shpno (itoa value)))
					((= acode 340)
						(if flag
							(progn
								(setq shxfl (cdr (assoc 3 (entget value)))
											shpfl (strcat (substr shxfl 1 (- (strlen shxfl) 3)) "shp"))
								(if (setq inf (findfile shpfl))
									(progn
										(setq inf (open inf "r"))
										(while (setq dat (read-line inf))
											(if (wcmatch dat (strcat "`*" shpno "*"))
												(progn
													(setq n 1)
													(repeat 2
														(while (/= (substr dat n 1) ",")
															(setq n (1+ n)))
														(setq n (1+ n)))
													(setq shpnm (substr dat n)))))
										(close inf)))))
						(setq flg flag
									txt (if flag
												(if shpnm shpnm (strcat "{Shape #" shpno "}"))
												(strcat "\"" (cdr (assoc 9 (member alist tblist))) "\""))
									sty (if flag
												(cdr (assoc 3 (entget value)))
												(cdr (assoc 2 (entget value))))
									desc (strcat desc "\n[" txt "," sty ",s="
															 (trim (rtos (cdr (nth (1+ i) tblist)) 2 8)) "," rot "="
															 (trim (angtos (cdr (nth (+ i 2) tblist)) 0 8)) ",x="
															 (trim (rtos (cdr (nth (+ i 3) tblist)) 2 8)) ",y="
															 (trim (rtos (cdr (nth (+ i 4) tblist)) 2 8)) "],\n")
									i (+ i 4)))
					(T nil))
				(setq i (1+ i)))
			(write-line (substr desc 1 (1- (strlen desc))) outf)
			(write-line " " outf)
			(close outf)
			(if (and flg (not shpnm))
				(alert (strcat "Der Linentyp " ltname " wurde in die exp_lt.lin geschrieben. Die Datei befindet sich in C:\Dokumente.\n"
											 "Dies ist ein komplexer Linientyp, der nur mit einer Shape-Datei (*.shp) dasgestellt werden kann. \n"
											 "Sie muessen im Besitz dieser Datei sein, ansonsten kann der Linientyp nicht exportiert werden.\n"
											 "Wenn Sie die Datei haben, beachten Sie folgeden Informationen:"
											 "\n"
											 "Der Name dieser Datei muss in der exp_lt.lin in den geschweiften Klammern {} beim entsprechenden Linientyp ersetzt werden und die .shp-Datei muss am Speicherort der .lin-Datei liegen. "))
				(alert (strcat "Der Linentyp " ltname " wurde in die exp_lt.lin geschrieben. Die Datei befindet sich in C:\Dokumente."))))
		(alert (strcat "Der Linentyp " ltname " wurde nicht gefunden!")))
	(princ)
)
(defun trim (x / i)
	(setq i (strlen x))
	(while (= (substr x i) "0")
		(setq i (1- i)
					x (substr x 1 i)))
	(if (= (substr x i) ".")
		(substr x 1 (1- i))
		x)
)